--------------------------------------------------------------------------------
-- Company: OHO-ELEKTRONIK
-- Engineer: <M.Randelzhofer>
--
-- Create Date: 1.10.2005
-- Design Name: GOP_XC9572XL_BLINK
--------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ucf_xc9572xl_blink is
Port (	osc : in std_logic ;
		rcout : in std_logic ;
		tp2,tp3,tp4,tp5,tp6,gck3: inout std_logic ;
		pin1,pin2,pin3,pin4,pin5,pin6,pin7,pin8,pin9,pin10,pin11: inout std_logic ;
		pin13,pin14,pin15,pin16,pin17,pin18,pin19,pin20,pin21,pin22,pin23: inout std_logic ;
		ledrd,ledgn,rcin : out std_logic);
end ucf_xc9572xl_blink;

architecture Behavioral of ucf_xc9572xl_blink is

component BUFG
 port (I:in STD_LOGIC; O:out STD_LOGIC) ;
end component;

component OBUF
 port (I:in STD_LOGIC; O:out STD_LOGIC) ;
end component;


signal clock:					STD_LOGIC ;

signal clkdiv:					STD_LOGIC_VECTOR (30 downto 0) ;







begin
-- use gck3 as global clock net
CLOCKOUT:	OBUF port map (I => osc, O => gck3) ;
CLOCKIN:	BUFG port map (I => gck3, O => clock) ;


-- Clock divider
-- dcdiv(0) = 24,576 MHz	40,7 ns
-- dcdiv(1) = 12,288 MHz	81,3 ns
-- dcdiv(2) =  6,144 MHz	163 ns
-- dcdiv(3) =  3,072 MHz	325 ns
-- dcdiv(4) =  1,536 MHz	651 ns
-- dcdiv(5) =    768 KHz	1,3 us
-- dcdiv(6) =    384 KHz	2,6 us
-- dcdiv(7) =    192 KHz	5,2 us
-- dcdiv(8) =     96 KHz	10,4 us
-- dcdiv(9) =     48 KHz	20,8 us
-- dcdiv(10) =    24 KHz	41,6 us
-- dcdiv(11) =    12 KHz	83,3 us
-- dcdiv(12) =     6 KHz	166 us
-- dcdiv(13) =     3 KHz	333 us

CLOCK_DIVIDE: process(clock)
begin
  if (clock'event and clock ='1') then
		clkdiv <= clkdiv + 1 ;

  end if ;
end process;

ledrd <= clkdiv(25) and tp2 ;
ledgn <= clkdiv(25) and not tp2 ;


end Behavioral;
